﻿var playlist_max_size = 8; //プレイリスト行数
var max_fetch_length = 2; //最大先読みfetch数
var saved_fetch_length = false; //先読みfetch数を保存するか
var saved_info_visible = true; //動画情報表示状態を保存するか
var saved_ichiba_visible = true; //ニコニコ市場表示状態を保存するか
var progress_hash = true; //再生位置をハッシュに保持するか

window.iconf_baseurl = 'http://ichiba.nicovideo.jp/embed/'; // ニコニコ市場のURL更新されたら変更しなければならない
window.rev = '20110526'; // ニコニコ市場のrev おそらく更新されたら変更しなければならない

var play_no = 0;
var next_no = 0;
var already_start = false;

var playListInfo = null;
var fetch_wait_id = null;
var desc_wait_id = null;

var sort_sign = [1,-1,-1,1,1,-1,-1,1,-1,1,-1,1,-1,1,-1,1,-1,1];
var sort_key = [
	'thread_id','thread_id','mylist_comment','mylist_comment',
	'title','title','create_time','create_time',
	'view_counter','view_counter','item_update_time','item_update_time',
	'num_res','num_res','mylist_counter','mylist_counter',
	'length_seconds','length_seconds'];

var sort_text_value = [1,0,4,5,2,3,6,7,8,9,10,11,12,13,14,15,16,17,9999];
var sort_text = [
	'登録が新しい順','登録が古い順','タイトル昇順','タイトル降順',
	'マイリストコメント昇順','マイリストコメント降順','投稿が新しい順','投稿が古い順',
	'再生が多い順','再生が少ない順','コメントが新しい順','コメントが古い順',
	'コメントが多い順','コメントが少ない順','マイリスト登録が多い順','マイリスト登録が少ない順',
	'時間が長い順','時間が短い順',
	'＜ランダム＞'];

var categoryTags = [
	"エンターテイメント","音楽","歌ってみた","演奏してみた","踊ってみた","VOCALOID","ニコニコインディーズ",
	"動物","料理","自然","旅行","スポーツ","ニコニコ動画講座","車載動画",
	"政治",
	"科学","ニコニコ技術部","ニコニコ手芸部","作ってみた",
	"アニメ","ゲーム","東方","アイドルマスター","ラジオ","描いてみた",
	"例のアレ","日記","その他",
	"R-18"];

$('flvplayer_container_loading').innerHTML =
	'<p class="font14">動画プレーヤーを準備しています…</p>' +
	'<p class="font10" style="margin-top:16px;">もうしばらくお待ちください。</p>';

var hint_view = document.createElement ('iframe');
document.body.appendChild (hint_view);
var hint_view_doc = (document.all ? hint_view.contentWindow.document : hint_view.contentDocument);
hint_view_doc.open ();
hint_view_doc.write (
	'<body style="text-align:center;font-size:12px;">' +
		'<h3 style="color:#C00;">リスト操作のヒント</h3>' +
		'<p>操作していて「？」と思ったら</p>' +
		'<ul style="border:1px solid #CCC;margin:10px auto;padding:10px 10px 10px 30px;width:560px;overflow:hidden;text-align:left;">' +
			'<li>動画リスト下にある横長の「動画の説明文」ボタンで動画の説明文表示をON/OFFできます。</li>' +
			'<li>動画説明文非表示時は右上の動画リストから目的の動画を選択することで動画を移動できます。</li>' +
			'<li>動画説明文表示時は右上の動画リストから目的の動画を選択することで該当の動画説明文が表示され、' +
				'選択状態でもう1度リストをクリックするか 説明文上部にある「読込」ボタンで移動します。</li>' +
			'<li>動画移動時の自動再生がうまく行われない場合、次のような理由が考えられます。' +
				'<ul style="margin:5px;">' +
					'<li>res.nimg.jp/js/watch.js へのフィルタが有効になっていない</li>' +
					'<li>ブラウザキャッシュで jsファイルが古い状態になっている</li>' +
				'</ul>' +
				'それぞれ、以下の対処を行ってみてください。' +
				'<ul style="margin:5px;">' +
					'<li>res.nimg.jp へのフィルタが有効になるようプロキシ設定を変更</li>' +
					'<li>ブラウザキャッシュを削除</li>' +
				'</ul>' +
			'</li>' +
		'</ul>'+
		'<p style="font-size:10px;">このヒントは 動画下の<strong style="color:#F00">「リスト操作のヒント」</strong>リンクで表示されます</p>' +
		'<input type="button" value="OK" onclick="javascript:parent.nico_playlist_toggle_hint()">' +
		'<div id="close_button">' +
			'<a href="javascript:void(0)" onclick="javascript:parent.nico_playlist_toggle_hint()">×</a>' +
		'</div>' +
		'<style type="text/css">' +
			'#close_button  { position:absolute;top:8px;right:12px;font-size:20px;font-weight:900;line-height:20px;}' +
			'#close_button a { color:#000;text-decoration:none; }' +
			'#close_button a:hover { color:#CCC; }' +
		'</style>' +
	'</body>');
hint_view_doc.close ();
hint_view.setAttribute ('style', 'background:#FFF;border:2px outset;position:fixed;top:50%;left:50%;z-index:10;display:none;');


if (so) {
	so.setAttribute ('swf', 'flvplayer_wrapper.swf?' + (new Date - 0));
	so.setAttribute ('width', 950);
	so.setAttribute ('height', 510);
	so.addVariable ('player_info_xml', 1280880000);
	so.addVariable ('player_version_xml', 1280880000);
	so.addVariable ('marqueeVersion', 1280880000);

	new Ajax.Request ('http://' + location.host + '/pr_Redirect_flapi.nicovideo.jp/api/getplaylist/' + location.href.match('/playlist/(mylist/.*)')[1], {
		method: 'GET',
		asynchronous: false,
		onSuccess: function (xhr, json) {
			playListInfo = (json) ? json : xhr.responseText.evalJSON ();

			var sort_type_num = so.getVariable ('playlistSort');
			if (location.hash.match(/[^\w]sort\=([^#&\?\=]+)/)) {
				sort_type_num = RegExp.$1;
			}
			for (var i=0; i<sort_text.length; i++) {
				var option = document.createElement ('option');
				option.appendChild(document.createTextNode (sort_text[i]));
				option.value = sort_text_value[i];
				option.selected = option.value == sort_type_num;
				$('playilist_sort_selector').appendChild (option);
			}
			$('playilist_sort_selector').onchange = nico_playlist_sort;
			nico_playlist_sort ();

			var from_id = so.getVariable ('playlistFrom');
			if (location.hash.match(/[^\w]from\=([^#&\?\=]+)/)) {
				from_id = RegExp.$1;
			}

			if (playListInfo.playlist.description && playListInfo.playlist.description.length > 0) {
				var top_dec =
					playListInfo.playlist.description.replace (
					/[　 ]{2,}(?![^「」\n]*」|.[　 ]|[\,\.、。])/g, '<br>');
				$('itab_list_description').innerHTML =
					'<p class="font12" style="padding:4px;">' + top_dec + '</P>';

				top_dec = top_dec.replace (/<br>/, '');
				if (top_dec.length >= 50) top_dec = top_dec.substring (0, 50) + '...';
				$('top_description').innerHTML = top_dec;

				$$('a[href="#itab_list_description"]').each (function (elm) { elm.style.display = 'inline'; });
			}

			for (var i = 0; i < playListInfo.items.length; i++) {
				var item = playListInfo.items[i];
				var option = document.createElement ('option');
				option.appendChild (document.createTextNode (item.title));
				if (from_id == item.thread_id) next_no = i;
				$('playilist_selector').appendChild (option);

				var date = new Date (item.create_time * 1000);
				var year   = date.getYear ();
				var month  = date.getMonth () + 1;
				var day    = date.getDate ();
				var hour   = date.getHours ();
				var minute = date.getMinutes ();
				var length_hour = Math.floor (item.length_seconds / 60);
				var length_minute = item.length_seconds % 60;
				if (year < 2000) year  += 1900;
				if (month  < 10) month  = '0' + month;
				if (day    < 10) day    = '0' + day;
				if (hour   < 10) hour   = '0' + hour;
				if (minute < 10) minute = '0' + minute;
				if (length_minute < 10) length_minute = '0' + length_minute;
				year = String (year).substr (-2);
				var desc = item.description || "";
				if (!desc.match (/<font|<b|<i|<s|<u|<br/i))
					desc = desc.replace (/[　 ]{2,}(?![^「」\n]*」|.[　 ]|[\,\.、。])/g, '<br>');
				desc = desc.replace (/(#\d+\:\d{1,2})(?!\d)/g, '<a href="#" onclick="seekNicoPlayer(\'$1\'); return false;">$1</a>');
				var dec = document.createElement('div');
				dec.id = 'playlist_info' + item.thread_id;
				dec.style.display = 'none';
				dec.innerHTML =
					'<div class="info_thumb des_item2">' +
						'<a href="javascript:void(0)" id="playlist_info_thumb_link" onclick="$(\'playlist_load\').onclick();" title="クリックで読み込み">' +
							'<img id="playlist_info_thumb' + item.thread_id + '" class="info_thumb_img" src="http://res.nimg.jp/img/x.gif" alt="">' +
							'<img id="playlist_info_thumb_cache' + item.thread_id + '" class="info_thumb_cache" src="http://res.nimg.jp/img/x.gif" alt="">' +
							'<span class="info_thumb_length">' + length_hour+':'+length_minute + '</span>' +
						'</a>' +
						'<a href="javascript:void(0)" class="info_thumb_switch des_item2" ' +
							'onclick="hideOBJs(\'des_item2\'); showOBJs(\'des_item1\'); ' +
							'this.parentNode.parentNode.parentNode.style.minHeight = \'\'; ' +
							'Cookie.set (\'playlist_info_visible\', \'0\', 1000*60*60*24*365, \'.nicovideo.jp\', \'/\');" ' +
							'title="詳細を隠す">≫</a>' +
					'</div>' +
					'<div style="float:right;">' +
						'<a href="javascript:void(0)" class="info_thumb_switch des_item1" ' +
							'onclick="hideOBJs(\'des_item1\'); showOBJs(\'des_item2\'); ' +
							'this.parentNode.parentNode.parentNode.style.minHeight = \'76px\'; ' +
							'Cookie.set (\'playlist_info_visible\', \'1\', 1000*60*60*24*365, \'.nicovideo.jp\', \'/\');" ' +
							'title="詳細を表示">≪</a>' +
					'</div>' +
					'<div id="playlist_info_text' + item.thread_id + '" class="info_text">' +
						'<p class="des_item2">' +
							'<nobr><strong>' + year+'/'+month+'/'+day+'/ '+hour+':'+minute + '</strong> 投稿&nbsp;</nobr>' +
							'<nobr>再生：<strong>' + item.view_counter + '</strong>&nbsp;</nobr>' +
							'<nobr>コメ：<strong>' + item.num_res + '</strong>&nbsp;</nobr>' +
							'<nobr>マイ：<strong>' + item.mylist_counter + '</strong>&nbsp;</nobr>' +
							'<a href="http://www.nicovideo.jp/openlist/' + item.video_id + '" title="公開マイリストを検索" '+
									'style="margin-left:5px;font-size:10px;">Op-ML</a>' +
							'<a id="playlist_delcache_link' + item.thread_id + '" href="javascript:void(0)" title="キャッシュを削除" ' +
									'onclick="nico_playlist_del_cache(this,\'' + item.video_id + '\',0)" style="margin-left:5px;color:#F00;font-size:10px;">DEL</a>' +
							'<a id="playlist_fetch_link' + item.thread_id + '" href="javascript:void(0)" title="動画の先読み込み" ' +
									'onclick="nicofetch(this,\'' + item.video_id + '\',0)" style="margin-left:5px;font-size:10px;display:none;">fetch</a>' +
						'</p>' +
						'<h2 class="des_item2">' +
							'<a href="/watch/' + item.video_id + '" onmouseover="javascript:void(0)">' + item.title + '</a>' +
						'</h2>' +
						'<p>' + desc + '</p>' +
					'</div>';
				$('itab_description').appendChild (dec);
				$('playing_title').innerHTML +=
						'<span id="playing_title' + item.thread_id + '" style="display:none;">' +
							'<a href="/watch/' + item.video_id + '" onmouseover="javascript:void(0)">' + item.title + '</a>&nbsp;' +
							'<a id="playlist_info_article_link' + item.thread_id + '" href="http://dic.nicovideo.jp/v/' + item.video_id +'" ' +
								'target="_blank" title ="大百科 ' + item.video_id + ' の記事" style="display:none;"></a>' +
							'<a id="playlist_info_toukome' + item.thread_id + '"  href="http://info.nicovideo.jp/help/player/script/owner.html" ' +
								'target="_blank" title="投コメ" style="display:none;"><img alt="" class="txticon" src="http://res.nimg.jp/img/watch/tit_icon/toukome.png"></a>' +
							'<a id="playlist_info_nicommons_link' + item.thread_id + '"  href="http://commons.nicovideo.jp/tree/' + item.video_id +'" ' +
								'target="_blank" title="コモンズ" style="display:none;"></a>' +
						'</span>';
			}
			$('playilist_selector').size = Math.min (playlist_max_size, playListInfo.items.length);
			$('playilist_selector').options[next_no].selected = true;
			$('playilist_selector_scroll_dummy').onscroll = function () {
				$('playilist_selector').scrollLeft = this.scrollLeft;
			};
			$('playilist_sort_selector').scrollselectitem = function () {
				var list = $('playilist_selector');
				var elem_space = 3 <= list.size ? 1 : 0;
				var elem_h = list.scrollHeight / Math.max (list.size, list.options.length);
				list.scrollTop = Math.min (Math.max (list.scrollTop, elem_h * (play_no + 1 + elem_space) - list.clientHeight), elem_h * (play_no - elem_space));
			};
			setTimeout (function () {
				var list = $('playilist_selector');
				if (list.scrollWidth > list.style.width) {
					var dummy = document.createElement ('div');
					dummy.style.width = list.scrollWidth + 'px';
					dummy.style.height = '1px';
					$('playilist_selector_scroll_dummy').appendChild (dummy);
					$('playilist_selector_scroll_dummy').style.width = list.clientWidth + 'px';
					$('playilist_selector_scroll_dummy').style.display = 'block';
					list.size = Math.min (playlist_max_size - 1, playListInfo.items.length);

					$('playilist_sort_selector').scrollselectitem();
				}
			}, 10);

			var select_chk = false;
			$('playilist_selector').onkeydown = function (event) {
				event = event || window.event;
				var key = event.keyCode || event.keyCode || event.which;
				if (key == 13 || key == 32) {
					if (event.preventDefault) event.preventDefault ();
					event.returnValue = false;
					$('playlist_load').onclick ();
				}
			};
			$('playilist_selector').onchange = function () {
				nico_playlist_update_desc ();
				select_chk = true;
				setTimeout (function () { select_chk = false; }, 10);
			};
			$('playilist_selector').onclick = function () {
				if (!select_chk)
					$('playlist_load').onclick ();
			};
			$('playlist_load').onclick = function () {
				if ($('flvplayer_container') && $('flvplayer_container').style.visibility == 'hidden')
					return;
				next_no = $('playilist_selector').selectedIndex;
				nico_playlist_end_func ();
			};
			var scroll_switcher = function (event) {
				var delta = 0;
				event = event || window.event;
				if (event.wheelDelta) { /* IE/Opera. */
					delta = event.wheelDelta/120;
					if (window.opera) delta = -delta;
				} else if (event.detail) { /** Mozilla case. */
					delta = -event.detail/3;
				}
				if (event.preventDefault) event.preventDefault ();
				event.returnValue = false;
			};

			$('playilist_current_select').onclick = function () {
				if ($('playilist_selector').selectedIndex != play_no && play_no != next_no) {
					$('playilist_selector').selectedIndex = play_no;
					nico_playlist_update_desc ();
				}
			};
			$('playilist_prev_select').onclick = function () {
				if ($('playilist_selector').selectedIndex > 0) {
					$('playilist_selector').selectedIndex--;
					nico_playlist_update_desc ();
				}
			};
			$('playilist_next_select').onclick = function () {
				if ($('playilist_selector').selectedIndex < playListInfo.items.length - 1) {
					$('playilist_selector').selectedIndex++;
					nico_playlist_update_desc ();
				}
			};
			var scroll_lock = null;
			var scroller = function (event) {
				var scrollcancel = $('playilist_selector').options.length <= $('playilist_selector').size;
				var delta = 0;
				event = event || window.event;

				//if (Element.hasClassName($('itab_description'), 'in')) {
					if (event.wheelDelta) { /* IE/Opera. */
						delta = event.wheelDelta/120;
						if (window.opera) delta = -delta;
					} else if (event.detail) { /** Mozilla case. */
						delta = -event.detail/3;
					}
					var target = event.target || window.event.srcElement;
					var select_no = $('playilist_selector').selectedIndex;
					for (var i=0; i<5 && target; i++, target=target.parentNode) {
						if (target.className === 'info_text') {
							scrollcancel = false;
							if ($('itab_description').scrollTop != playlist_info_height * select_no) target = null;
							break;
						}
					}
					if (target && target.className === 'info_text') {
						var acrive_info = $('playlist_info_text' + playListInfo.items[select_no].thread_id);
						if ((delta > 0 && acrive_info.scrollTop > 0) || (delta < 0 && acrive_info.scrollTop < acrive_info.scrollHeight - playlist_info_height)) {
							if (scroll_lock) clearTimeout (scroll_lock);
							scroll_lock = setTimeout (function () { scroll_lock = null; }, 250);
							delta = 0;
						}
					} else {
						if (scroll_lock) clearTimeout (scroll_lock);
						scroll_lock = null;
					}
				//}
				if (scrollcancel || delta != 0) {
					if (event.preventDefault) event.preventDefault ();
					event.returnValue = false;
				}
				if (!scroll_lock) {
					if (delta > 0) $('playilist_prev_select').onclick();
					if (delta < 0) $('playilist_next_select').onclick();
				}
			};
			if ($('playilist_selector').addEventListener) $('playilist_selector').addEventListener ('DOMMouseScroll', scroller, false);
			$('playilist_selector').onmousewheel = scroller;
			if ($('itab_description').addEventListener) $('itab_description').addEventListener ('DOMMouseScroll', scroller, false);
			$('itab_description').onmousewheel = scroller;

			for (var i = 0; i <= max_fetch_length; i++) {
				var option = document.createElement ('option');
				option.appendChild(document.createTextNode(i));
				if (saved_fetch_length && i == parseInt (Cookie.get ('playlist_fetch_length'))) {
					Cookie.set('playlist_fetch_length', i, 1000*60*60*24*365, '.nicovideo.jp', '/');
					option.selected = true;
				}
				$('playlist_fetch_selector').appendChild (option);
			}
			$('playlist_fetch_selector').onchange = nico_playlist_fetch;
			var scroll_fetcher = function (event) {
				var delta = 0;
				event = event || window.event;
				if (event.wheelDelta) { /* IE/Opera. */
					delta = event.wheelDelta/120;
					if (window.opera) delta = -delta;
				} else if (event.detail) { /** Mozilla case. */
					delta = -event.detail/3;
				}
				if (delta > 0 && $('playlist_fetch_selector').selectedIndex > 0) {
					$('playlist_fetch_selector').selectedIndex--;
					$('playlist_fetch_selector').onchange ();
				}
				if (delta < 0 && $('playlist_fetch_selector').selectedIndex < $('playlist_fetch_selector').options.length - 1) {
					$('playlist_fetch_selector').selectedIndex++;
					$('playlist_fetch_selector').onchange ();
				}
				if (event.preventDefault) event.preventDefault ();
				event.returnValue = false;
			};
			if ($('playlist_fetch_selector').addEventListener) $('playlist_fetch_selector').addEventListener ('DOMMouseScroll', scroll_fetcher, false);
			$('playlist_fetch_selector').onmousewheel = scroll_fetcher;

			if (window.nlMovieFetcher) $('playlist_fetch').style.display = 'inline';

			Nico.onReady (function () {
				if ($('playilist_nicoichiba_switcher')) {
					$('playilist_nicoichiba_switcher').onclick = function () {
						if ($('ichiba_placeholder').style.display == 'none') {
							$('ichiba_placeholder').style.display = 'block';
							$('playilist_nicoichiba_switcher').innerHTML = 'ニコニコ市場▲';
							nico_playlist_ichiba_load ();
							if (saved_ichiba_visible) Cookie.set ('playlist_ichiba_visible', 1, 1000*60*60*24*365, '.nicovideo.jp', '/');
						} else {
							$('ichiba_placeholder').style.display = 'none';
							$('playilist_nicoichiba_switcher').innerHTML = 'ニコニコ市場▼';
							if (saved_ichiba_visible) Cookie.set ('playlist_ichiba_visible', 0, 1000*60*60*24*365, '.nicovideo.jp', '/');
						}
					};
					if (saved_ichiba_visible) {
						if (Cookie.get ('playlist_ichiba_visible') == 1) $('playilist_nicoichiba_switcher').onclick();
						else  Cookie.set ('playlist_ichiba_visible', 0, 1000*60*60*24*365, '.nicovideo.jp', '/');
					}
				}
			});
			$('WATCHHEADER').show_org = $('WATCHHEADER').show;
			$('WATCHHEADER').show = function () {
				$('WATCHHEADER').show_org();
				$('playilist_sort_selector').scrollselectitem();
				if (Cookie.get('hbs') != '1') hideOBJ('PAGEHEADER');
			};
			$('video_controls').show_org = $('video_controls').show;
			$('video_controls').show = function () {
				$('video_controls').show_org();
				playListInfo.items[play_no].wv_time = undefined;

				var tags_list = new Array();
				var tags = $('video_tags').getElementsByTagName ('nobr');
				for (var i = 0; i < tags.length; i++) {
					var a = tags[i].getElementsByTagName ('a').item (0);
					if (!Element.hasClassName(a, 'nicopedia') || Element.hasClassName(a, '__nicopedia_loaded')) break;
					tags_list.push (a.innerHTML);
				}
				if (tags_list.length == tags.length - 1 &&
					playListInfo.items[play_no].videoDetail && playListInfo.items[play_no].videoDetail.tags ) {
					playListInfo.items[play_no].videoDetail.tags = tags_list;
					//tagcheck ();
				}
			};
			if ($('user_thumb')) {
				var use_id = playListInfo.playlist.user_id;
				$('user_thumb').innerHTML =
					'<a href="user/' + use_id + '"><img class="img_sq48" alt="" src="http://usericon.nimg.jp/usericon/' +
					(use_id.length <= 4 ? '0' : use_id.substring (0, use_id.length - 4)) + '/' + use_id + '.jpg?' + Math.floor(new Date / 1000) +'"' +
					'onload="javascript:$(\'user_thumb\').style.display=\'block\';" ' +
					'onerror="javascript:$(\'user_thumb\').style.display=\'none\';"></a>';
			}

			if (from_id) {
				nico_playlist_end_func ();
				if (Cookie.get ('desopen') == 0) {
					showOBJs ('des_1');
					Cookie.set ('desopen', '0', 1000*60*60*24*365, '.nicovideo.jp', '/');
				} else {
					showOBJs ('des_2');
					Cookie.set ('desopen', '1', 1000*60*60*24*365, '.nicovideo.jp', '/');
				}
			} else {
				nico_playlist_update_desc ();
				already_start = true;
				$('playilist_index').innerHTML = '[-/' + playListInfo.items.length + ']';
				$('flvplayer_container_loading').innerHTML =
					'<p class="font14">右上の動画リストから任意の動画を読み込んでください。</p>' +
					'<p class="font10" style="margin-top:16px;">最初の動画が未選択です。</p>';
				showOBJs ('des_2');
			}
			if (Cookie.get ('playlist_info_visible') != 1) {
				hideOBJs('des_item2'); showOBJs ('des_item1');
				$("itab_description").style.minHeight = '';
				Cookie.set ('playlist_info_visible', '0', 1000*60*60*24*365, '.nicovideo.jp', '/');
			} else {
				hideOBJs('des_item1'); showOBJs ('des_item2');
				$("itab_description").style.minHeight = '76px';
				Cookie.set ('playlist_info_visible', '1', 1000*60*60*24*365, '.nicovideo.jp', '/');
			}
		}
	});
}

function nico_playlist_update_desc () {
	var item = playListInfo.items[$('playilist_selector').selectedIndex];
	new Ajax.Request ('http://' + location.host + '/pr_Redirect_www.nicovideo.jp/cache/ajax_info', {
		method: 'GET', parameters : item.video_id, asynchronous: false,
		onSuccess : function(res){
			if (res.responseText.match(/^OK,([^,]*),[^,]*,[^,]*,0,/)) {
				var cache = RegExp.$1 == 'low' ? 'economy' : 'icon';
				$('playlist_info_thumb_cache' + item.thread_id).src = 'http://www.nicovideo.jp/local/cache' + cache + '.gif';
				$('playlist_info_thumb_cache' + item.thread_id).style.visibility = 'visible';
			} else {
				$('playlist_info_thumb_cache' + item.thread_id).style.visibility = 'hidden';
			}
		}
	});
	if (window.nlMovieFetcher) $('playlist_fetch_link' + item.thread_id).style.display = 'inline';
	$('playlist_delcache_link' + item.thread_id).innerHTML = 'DEL';
	$('playlist_info_thumb' + item.thread_id).src = item.thumbnail_url;

	if (item.mylist_comment) {
		$('itab_mylist').innerHTML =
			'<p class="font12" style="padding:4px;">' + item.mylist_comment + '</P>';
		$('itab_mylist').style.backgroundColor = play_no == $('playilist_selector').selectedIndex ? 'transparent' : '#DDD';
		$$('a[href="#itab_mylist"]').each(function(elm) { elm.style.display = 'inline'; });
	} else {
		if (Element.hasClassName($('itab_mylist'), 'in')) {
			$$('a[href="#itab_description"]').each (function (elm) { elm.addClassName ('in'); });
			$$('a[href="#itab_mylist"]').each (function (elm) { elm.removeClassName ('in'); });
			$('itab_description').addClassName ('in');
			$('itab_mylist').removeClassName ('in');
		}
		$$('a[href="#itab_mylist"]').each (function (elm) { elm.style.display = 'none'; });
	}
	for (var i = 0; i < $('itab_description').childNodes.length; i++)
		$('itab_description').childNodes[i].style.display = (i == $('playilist_selector').selectedIndex ? 'block' : 'none');
	$('itab_description').style.backgroundColor = play_no == $('playilist_selector').selectedIndex ? 'transparent' : '#DDD';
	$('playilist_selector_scroll_dummy').onscroll();
}

function nico_playlist_update () {
	var list = $('playilist_selector');
	play_no = list.selectedIndex;
	next_no = play_no + 1;
	for (var i = 0; i < list.options.length; i++) {
		list.options[i].style.backgroundColor = i == play_no ? '#CFD' : 'transparent';
		list.options[i].style.color = i == play_no ? '#F00' : 'inherit';
	}
	for (var i = 0; i < playListInfo.items.length; i++) {
		$('playing_title' + playListInfo.items[i].thread_id).style.display = $('playilist_selector').selectedIndex == i ? 'inline' : 'none';
	}
	var item = playListInfo.items[$('playilist_selector').selectedIndex];
	var article_link = $('playlist_info_article_link' + item.thread_id);
	if (article_link.style.display != 'inline') {
		new Ajax.Request ('http://' + location.host + '/pr_Redirect_api.nicodic.jp/page.exist/a/v/' + item.video_id, {
			method: 'GET', parameters : (new Date - 0), asynchronous: false,
			onSuccess : function (res) {
				var flag = res.responseText.match(/\(1\)/);
				article_link.title += 'を' + (flag?'読む':'書く');
				article_link.innerHTML = '<img alt="" class="txticon" src="http://res.nimg.jp/img/common/icon/dic_' + (flag?'on':'off') +'.png">';
				article_link.style.display = 'inline';
			}
		});
	}
	var nicommons_link = $('playlist_info_nicommons_link' + item.thread_id);
	if (nicommons_link.style.display != 'inline') {
		new Ajax.Request ('http://' + location.host + '/pr_Redirect_api.commons.nicovideo.jp/status/nicovideo/' + item.video_id, {
			method: 'GET', parameters : 'callback=a', asynchronous: false,
			onSuccess : function (res) {
				if (res.responseText.match(/"rel":1/))
					nicommons_link.innerHTML = '<img alt="" class="txticon" src="http://res.nimg.jp/img/watch/tit_icon/commons.png">';
				nicommons_link.style.display = 'inline';
			}
		});
	}
	$('playilist_index').innerHTML = '[' + (play_no + 1) + '/' + playListInfo.items.length + ']';

	var elem_space = 3 <= list.size ? 1 : 0;
	var elem_h = list.scrollHeight / Math.max (list.size, list.options.length);
	list.scrollTop = Math.min (Math.max (list.scrollTop, elem_h * (play_no + 1 + elem_space) - list.clientHeight), elem_h * (play_no - elem_space));

	if (progress_hash) {
		var hash = '';
		var sort_type_num = $('playilist_sort_selector').options[$('playilist_sort_selector').selectedIndex].value;
		var from_id = playListInfo.items[play_no].thread_id;
		if (sort_type_num != so.getVariable ('playlistSort')) hash += (hash ? '&sort=' : 'sort=') + sort_type_num;
		if (from_id != so.getVariable ('playlistFrom')) hash += (hash ? '&from=' : 'from=') + from_id;

		//if (hash) location.hash = hash;
		if (hash || location.hash) location.replace (location.href.replace (/#[^#]*$/, '') + '#+' + hash );
	}
	nico_playlist_update_desc ();
}

function nico_playlist_sort () {
	var play_id = playListInfo.items[play_no].thread_id;
	var sort_type = $('playilist_sort_selector').options[$('playilist_sort_selector').selectedIndex].value;
	if (0 <= sort_type) {
		if (sort_type<sort_key.length) {
			playListInfo.items.sort (function (a,b) {
				if (sort_type<2 || 5<sort_type) return (a[sort_key[sort_type]]-b[sort_key[sort_type]]) * sort_sign[sort_type];
				if (a[sort_key[sort_type]]>b[sort_key[sort_type]]) return sort_sign[sort_type];
				if (a[sort_key[sort_type]]<b[sort_key[sort_type]]) return -sort_sign[sort_type];
				return 0;
			});
		} else {
			for (var i = 0; i < playListInfo.items.length - 1; i++) {
				var j = i + Math.floor (Math.random () * (playListInfo.items.length - i) );
				var tmp = playListInfo.items[i];
				playListInfo.items[i] = playListInfo.items[j];
				playListInfo.items[j] = tmp;
			}
		}
		for (var i = 0; i < $('itab_description').childNodes.length; i++)
			$('itab_description').insertBefore ($('playlist_info' + playListInfo.items[i].thread_id), $('itab_description').childNodes[i] );

		if (0 < $('playilist_selector').options.length) {
			for (var i = 0; i < playListInfo.items.length; i++) {
				$('playilist_selector').options[i].text = playListInfo.items[i].title;
				if (play_no != next_no ? playListInfo.items[i].thread_id == play_id : $('playilist_selector').selectedIndex == i) {
					$('playilist_selector').selectedIndex = i;
					$('itab_description').childNodes[i].style.display = 'block';
				} else {
					$('itab_description').childNodes[i].style.display = 'none';
				}
			}
			if (play_no != next_no) nico_playlist_update ();
			else nico_playlist_update_desc ();

			if (fetch_wait_id) clearTimeout (fetch_wait_id);
			fetch_wait_id = setTimeout (function () {
				nico_playlist_fetch ();
				fetch_wait_id = null;
			}, 10000);
		}
	}
}

function nico_playlist_fetch () {
	if (window.nlMovieFetcher && next_no != play_no) {
		var len = $('playlist_fetch_selector').selectedIndex;
		for (var i = 0; i<len && next_no+i<playListInfo.items.length; i++) {
			var link = $('playlist_fetch_link' + playListInfo.items[next_no+i].thread_id);
			if (link.innerHTML == 'fetch')
				nicofetch (link, playListInfo.items[next_no+i].video_id, 0);
		}
	}
	if (saved_fetch_length)
		Cookie.set('playlist_fetch_length', len, 1000*60*60*24*365, '.nicovideo.jp', '/');
}

function nico_playlist_toggle_hint () {
	if (hint_view.style.display === 'none') {
		hint_view.style.display = 'block';
		var doc = (document.all ? hint_view.contentWindow.document : hint_view.contentDocument);
		var width = doc.body.scrollWidth + 20;
		var height = doc.body.scrollHeight + 5;
		hint_view.style.width = width + 'px';
		hint_view.style.height = height + 'px';
		hint_view.style.marginLeft = -width / 2 + 'px';
		hint_view.style.marginTop = -height / 2 + 'px';
	} else {
		hint_view.style.width = '';
		hint_view.style.height = '';
		hint_view.style.display = 'none';
	}
}

function nico_playlist_del_cache (elem, smid) {
	if (!window.confirm (smid + 'のキャッシュを削除します')) return;

	new Ajax.Request ('http://' + location.host + '/pr_Redirect_www.nicovideo.jp/cache/ajax_rm', {
		method: 'GET', parameters : smid, asynchronous: false,
		onSuccess : function (res){
			nico_playlist_update_desc ();
			if (elem) {
				elem.innerHTML = 'DEL(' + res.responseText + ')';
				elem.title = 'キャッシュの削除に' + (res.responseText.match(/^OK/) ? '成功' : '失敗');
			}
		}
	});
}

function nico_playlist_ichiba_load () {
	if (!window.Video || $('ichiba_placeholder').style.display == 'none') return;
	if (window.Video.id != window.video_id) {
		window.video_id = Video.id;
		window.user_id  = User.id.toString();

		$('ichiba_placeholder').innerHTML =
			'<p class="font16" style="color:#C00; text-align:center; padding:4px;">ニコニコ市場を読み込んでいます…</p>';

		if (window.ichiba_reload !== 'function') {
			var sc = document.createElement ('script');
			sc.type = 'text/javascript';
			sc.src = iconf_baseurl + 'ichiba.js?rev=' + rev;
			sc.setAttribute ('defer', true);
			sc.setAttribute ('async', true);
			var hd = document.getElementsByTagName ('head').item (0);
			hd.appendChild (sc);
		} else {
			window.ichiba_reload (window.video_id, window.country, (window.Video.channelId || ''));
		}
	}
}

function tagcheck () {
	var tags = $('video_tags').getElementsByTagName ('nobr');

	for (var i = 0; i < tags.length - 1; i++) {
		var elem = tags[i];
		var a = elem.getElementsByTagName ('a').item (0);
		var tag = a.innerHTML;
		if (!Element.hasClassName(a, 'nicopedia') || Element.hasClassName(a, '__nicopedia_loaded')) continue;

		var req_url, dic_url;
		if (tag.match(/((?:sm|nm|so|ca|ax|yo|nl|ig|na|cw|z[a-e]|om|sk|yk)\d{1,8}|\d{10})(?!\d)/)) {
			tag = RegExp.$1;
			req_url = 'http://' + location.host + '/pr_Redirect_api.nicodic.jp/page.exist/a/v/' + tag;
			dic_url = 'http://dic.nicovideo.jp/v/' + tag;
		} else {
			req_url = 'http://' + location.host + '/pr_Redirect_api.nicodic.jp/e/a/' + encodeURIComponent (tag);
			dic_url = 'http://dic.nicovideo.jp/a/' + encodeURIComponent (tag);
		}
		new Ajax.Request (req_url, {
			method: 'GET', parameters : (new Date - 0), asynchronous: false,
			onSuccess : function (res){
				var flag = res.responseText.match(/\[1\]/);
				a.className = 'nicopedia __nicopedia_loaded';
				elem.innerHTML = elem.innerHTML.substring (0, elem.innerHTML.lastIndexOf ('>') + 1) +
					'<a href="' + dic_url +'" target="_blank" ' +
					'title="大百科 ' + tag + ' の記事を' + (flag?'読む':'書く') + '">' +
					'<img alt="" class="txticon" src="http://res.nimg.jp/img/common/icon/dic_' + (flag?'on':'off') +'.png"></a>&nbsp;';
			}
		});
	}
}

function nico_playlist_item_load (item) {
	var tags_locked_category = new Array();
	var tags_locked = new Array();
	var tags_category = new Array();
	var tags = $('video_tags');
	tags.innerHTML = '';

	item.videoDetail.tags.each (function (tag) {
		var isCategory = false;
		categoryTags.each (function (categoryTag) {
			if (tag == categoryTag) isCategory = true;
		});
		var isLocked = false;
		if (item.videoDetail.lockedTags instanceof Array) {
			item.videoDetail.lockedTags.each (function (lockedTag) {
				if (tag == lockedTag) isLocked = true;
			});
		}
		if (isLocked && isCategory) tags_locked_category.push (tag);
		else if (isLocked) tags_locked.push (tag);
		else if (isCategory) tags_category.push (tag);

		var nobr = document.createElement ('nobr');
		if (tag.match(/((?:sm|nm|so|ca|ax|yo|nl|ig|na|cw|z[a-e]|om|sk|yk)\d{1,8}|\d{10})(?!\d)/)) {
			nobr.innerHTML =
				'<a href="http://www.nicovideo.jp/watch/' + RegExp.$1 + '" rel="tag" class="nicopedia">' + tag + '</a>&nbsp;';
		} else {
			nobr.innerHTML =
				(tag == item.category ? '<img src="http://res.nimg.jp/img/watch/ctg.png" alt="カテゴリ" style="vertical-align:middle;margin-right:2px;">' : '') +
				'<a href="tag/' + encodeURIComponent(tag) + '" rel="tag" class="nicopedia">' + tag + '</a>&nbsp;';
		}
		tags.appendChild (document.createTextNode('\n\t\t'));
		tags.appendChild (nobr);
	});
	var nobr = document.createElement ('nobr');
	nobr.innerHTML =
		'<a href="javascript:startTagEdit(\'http://www.nicovideo.jp/tag_edit/' + item.video_id + '\');" style="color:rgb(204,0,0);">【編集】</a>';
	tags.appendChild (document.createTextNode ('\n\t\t'));
	tags.appendChild (nobr);
	tags.appendChild (document.createTextNode ('\n'));

	var stylesheet = $('tag_style').sheet;
	for (var i = 0; stylesheet == undefined && i<document.styleSheets.length; i++)
	{
		if (document.styleSheets[i].id == 'tag_style') stylesheet = document.styleSheets[i];
	}
	if (stylesheet.cssRules)
		while (stylesheet.cssRules.length) stylesheet.deleteRule(0);
	else if (stylesheet.rules)
		while (stylesheet.rules.length) stylesheet.removeRule();

	if (tags_locked_category.length) {
		var style = 'content:"C★";color:#F90;font-weight:bold;';
		var selector = '#video_tags a[href="tag/' + encodeURIComponent(tags_locked_category[0]) + '"]:before ';
		for (var i = 1; i < tags_locked_category.length; i++)
			selector += ', #video_tags a[href="tag/' + encodeURIComponent(tags_locked_category[i]) + '"]:before ';

		if (stylesheet.insertRule) stylesheet.insertRule (selector + ' {' + style + '}', stylesheet.cssRules.length);
		else if (stylesheet.addRule) stylesheet.addRule (selector, style);
	}
	if (tags_locked.length) {
		var style = 'content:"★";color:#F90;font-weight:bold;';
		var selector = '#video_tags a[href="tag/' + encodeURIComponent(tags_locked[0]) + '"]:before ';
		for (var i = 1; i < tags_locked.length; i++)
			selector += ', #video_tags a[href="tag/' + encodeURIComponent(tags_locked[i]) + '"]:before ';

		if (stylesheet.insertRule) stylesheet.insertRule (selector + ' {' + style + '}', stylesheet.cssRules.length);
		else if (stylesheet.addRule) stylesheet.addRule (selector, style);
	}
	if (tags_category.length) {
		var style = 'content:"C";color:#F90;font-weight:bold;';
		var selector = '#video_tags a[href="tag/' + encodeURIComponent(tags_category[0]) + '"]:before ';
		for (var i = 1; i < tags_category.length; i++)
			selector += ', #video_tags a[href="tag/' + encodeURIComponent(tags_category[i]) + '"]:before ';

		if (stylesheet.insertRule) stylesheet.insertRule (selector + ' {' + style + '}', stylesheet.cssRules.length);
		else if (stylesheet.addRule) stylesheet.addRule (selector, style);
	}
	$('video_controls').show_org();

	var FLVPLAYER = document.getElementById ('flvplayer');
	if (FLVPLAYER && typeof FLVPLAYER.ext_reload === 'function') {
		FLVPLAYER.ext_reload (item);
	} else {
		for (var i in item) {
			if (typeof item[i] === 'string') so.addVariable (i, encodeURIComponent (item[i]));
		}
		$('flvplayer_container').style.visibility = 'visible';

		if (!so.write ('flvplayer_container')) {
			if ($('flvplayer_container_loading')) $('flvplayer_container_loading').hide();
			if ($('flvplayer_container_install')) $('flvplayer_container_install').show();
			return;
		}
	}
	Nico.onReady (function () { changePlayingVideo(item.video_id, item.thread_id); });
	NicoPlayerReady.register (function () {
		var FLVPLAYER = document.getElementById ('flvplayer');
		if (FLVPLAYER) {
			if (typeof FLVPLAYER.ext_addEndFunc === 'function') {
				FLVPLAYER.ext_addEndFunc ('nico_playlist_end_func');
				if (already_start) FLVPLAYER.ext_play (true);
			}
		}
		already_start = true;
		nico_playlist_fetch ();
		tagcheck ();
	}, 'reset');
	window.Video = item.videoDetail;
	nico_playlist_ichiba_load ();

	if (item.has_owner_thread) {
		$('playlist_info_toukome' + item.thread_id).style.display = 'inline';
	}
}

function nico_playlist_end_func () {
	if (!playListInfo) return false;

	var FLVPLAYER = document.getElementById ('flvplayer');
	if (FLVPLAYER) {
		if (playListInfo.items.length <= next_no) {
			if (typeof FLVPLAYER.ext_isRepeat !== 'function' || !FLVPLAYER.ext_isRepeat ())
				return false;
			next_no = 0;
		}
		FLVPLAYER.ext_play (false);
	}
	if (!FLVPLAYER || typeof FLVPLAYER.ext_reload !== 'function') {
		$('flvplayer_container').style.visibility = 'hidden';
		if (playerMaximized) {
			restorePlayer ();
			playerMaximized = false;
		}
	}
	if ($('tag_edit_form')) {
		loading = false;
		$('tag_edit_form').remove();
	}
	var item = playListInfo.items[next_no];
	setTimeout (function () {
		if (!item.wv_time || new Date / 1000 - item.wv_time > 60*5) {
			new Ajax.Request ('http://' + location.host + '/pr_Redirect_www.nicovideo.jp/watch/' + item.thread_id + '?playlist_token=' + playListInfo.playlist_token + '&mode=playlist', {
				method: 'GET',
				asynchronous: false,
				onSuccess: function (xhr, json) {
					var data = (json) ? json : xhr.responseText.evalJSON ();
					for (var i in data) item[i] = data[i];
					nico_playlist_item_load (item);
				}
			});
		} else { nico_playlist_item_load (item); }
	}, 0);
	$('playilist_selector').selectedIndex = next_no;
	nico_playlist_update ();
	return true;
}
